<script>
  import { extent } from "d3-array";
  import { select } from "d3-selection";
  import { scaleLinear } from "d3-scale";
  import { axisBottom, axisLeft } from "d3-axis";
  import { brush } from "d3-brush";

  // Properties
  export let data = [];
  export let x = (d) => d.x;
  export let y = (d) => d.y;
  export let xLabel = "x";
  export let yLabel = "y";

  export let selected_both;
  export let selected_local;

  // Dimensions
  const width = 400;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 35, left: 45 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Scales
  const xScale = scaleLinear().domain(extent(data, x)).range([0, innerWidth]);
  const yScale = scaleLinear().domain(extent(data, y)).range([innerHeight, 0]);

  // Axes
  const xAxis = (node) => axisBottom(xScale)(select(node));
  const yAxis = (node) => axisLeft(yScale)(select(node));

  // Brushing
  // The range of the selection rectangle.
  // If there is no active selection, it contains: null,
  // otherwise, it contains: [ [x0, y0], [x1, y1] ]
  let range = null;
  const myBrush = (node) => brush().on("start brush end", brushed)(select(node));

  function brushed ({selection}) {
    if (selection) {
        range = selection;
      } else {
        range = null;
      }
  }
  $: if (range) {
    const [ [x0, y0], [x1, y1] ] = range;
    selected_local = coords.map((d) => (x0 < d.x && d.x < x1 && y0 < d.y && d.y < y1)); 
  } else {
    selected_local = coords.map(() => true);
  }

  let coords = data.map(d => { return { x: xScale(x(d)), y: yScale(y(d)) }; });


/*   const [[x0,y0],[x1,y1]] = [[80,14],[140,18]];
  range = [[x0,y0], [x1,y1]];

  function selected_local(d){
    if (50 < x(d) && x(d) < 150 && 14 < y(d) && y(d) < 20) {
      return true;
    } else {
      return false;
    }
  }

  // Define the brush:
  const myBrush = brush()
    .on('start',doStart)
    .on('brush',doMove)
    .on('end',doEnd);


  // What to do at the start of the brush
  function doStart(){
   }
  
  // sets the selection points
  function doMove({selection}){
    range 
  }

  // if brush is empty, select all circles:
  function doEnd(){
  } */

</script>

<!-- svelte-ignore component-name-lowercase -->
<svg viewBox="0 0 {width} {height}" class="mx-2" style="max-width: {width}px">
  <g transform="translate({margin.left},{margin.top})" use:myBrush>
    <g>
      {#each data as d, i}
        <circle
          cx={xScale(x(d))}
          cy={yScale(y(d))}
          r={3}
          fill= {selected_both[i] ? "steelblue" : "darkgray"}
          fill-opacity={selected_both[i] ? 0.5 : 0.3}
          stroke={selected_both[i] ? "steelblue" : "darkgray"}
          stroke-width={selected_both[i] ? 1.3 : 1}
          stroke-opacity={selected_both[i] ? 1 : 0.5}
        />
      {/each}
    </g>
    <g use:xAxis transform="translate(0, {innerHeight})">
      <text class="axisLabel" x={innerWidth / 2} y={margin.bottom - 5}
        >{xLabel}</text
      >
    </g>
    <g use:yAxis>
      <text
        class="axisLabel"
        y={-margin.left + 10}
        x={-innerHeight / 2}
        transform="rotate(-90)">{yLabel}</text
      >
    </g>
  </g>
</svg>

<style>
  .axisLabel {
  text-anchor: middle;
  vertical-align: bottom;
  fill: currentcolor;
}
</style>


